import io from "socket.io-client";


const socket = io("http://localhost:3001");
export default socket;

/**
 * Promisify emit.
 * @param event
 * @param arg
 */
export function emit(event: string, arg: any = null) {
    return new Promise((resolve, reject) => {
        const cb = (err: any, res: any) => {
            if (err) {
                return reject(err);
            }

            resolve(res);
        };

        if (arg === null || typeof arg === 'undefined') {
            socket.emit(event, cb);
        } else {
            socket.emit(event, arg, cb);
        }

    })
}